(* COPYRIGHT (C) 1989 BY JOHN R. CARLING AND MAITRIX SOFTWARE PUBLISHERS *)

{
   WARNING: This source code is included only for the implementation stage of
   TAIME.  There is NOTHING wrong with this source code, and NO CHANGES ARE
   NEEDED WHAT-SO-EVER.  John R. Carling and Maitrix Software Publishers ARE
   NOT RESPONSIBLE for your negligence if changes are made.  Again, I warn you,
   ANY change to this particular source code will corrupt the prototype you
   are constructing.  Again, I cannot stress this importance, but if you feel
   that you must, especially DO NOT EDIT THE TYPE DEFINITION OF THE MENU_REC,
   that includes MENU_LINE, MENU_TABLE, CHAR_TABLE.  Without any doubt in my
   mind, changes to the MENU types WILL BLOW UP IN YOUR FACE.

}

UNIT GEN_MENU;

INTERFACE
  USES CRT, KEYDEFS;

TYPE
     MENU_LINE  = STRING [60];
     MENU_TABLE = ARRAY  [1..10] OF MENU_LINE;
     CHAR_TABLE = ARRAY  [1..10] OF CHAR;

     MENU_REC = RECORD
                  FOREGROUND:BYTE;
                  BACKGROUND:BYTE;
                  NUM_OF_CHOICES:BYTE;
                  MENU_WIDTH:BYTE;
                  MENU_KEYS :CHAR_TABLE;
                  CHOICES   :MENU_TABLE;
                  DESCRIPT  :MENU_TABLE;
                  TITLE     :MENU_LINE;
                  PROMPT    :MENU_LINE;
                END;

PROCEDURE GET_MENU_RESPONCE(MENU:MENU_REC; VAR CHOICE:CHAR);

PROCEDURE DISPLAY_MENU(MENU:MENU_REC);


IMPLEMENTATION


(* DISPLAYS A FRAME AROUND THE MENU, USING A SINGLE LINE *)
PROCEDURE DISPLAY_FRAME(NUM_LINES, NUM_COLS:INTEGER);
VAR LEFT_COL, TOP_LINE,
    COL, LINE, DUMMY   :BYTE;
BEGIN
     (* Limit the screen size to actual size of screen *)
     IF Num_Lines > 20 then Num_Lines :=20;
     IF Num_Cols  > 73 then Num_Cols  :=73;

     Top_Line := 5;
     Left_Col := 40 - (Num_Cols div 2) - 3;  { subtract 3 for frame width  }
     If Left_Col < 1 then Left_Col := 1;

{ * display the top line * }
     GotoXy(Left_col, Top_Line);
     Write (' ', #218);
     For Col := 1 to Num_Cols + 2 Do Write (#196);
     Write (#191,' ');

{ * display 2nd line, under title bar * }
     GotoXy(Left_Col, Top_Line + 2);
     For Col:= 1 to Num_cols + 4 Do Write (#220);

{ * display middle lines / colunms * }
     Dummy := Top_Line + Num_Lines + 4;
     For Line := Top_Line + 1 to Dummy Do
     Begin
        GotoXy (Left_Col, Line);                 Write  (' ',#179,' ');
        GotoXy (Left_Col + Num_Cols + 3, Line);  Write  (' ',#179,' ');
     End;

{ * display highlight bars for menu choice descriptions * }
     GotoXy(Left_Col, Top_Line + Num_lines + 1);
     Write (' ',#179,' ');
     For Col := 1 to Num_Cols Do Write (#205);
     Write (' ',#179,' ');

     GotoXy(Left_Col, Top_Line + Num_lines + 3);
     Write (' ',#179,' ');
     For Col := 1 to Num_Cols Do Write (#205);
     Write (' ',#179,' ');

{ * display the last line * }
     GotoXy(Left_Col, Top_Line + Num_Lines + 5);
     Write (' ',#192);
     For Col := 1 to Num_Cols + 2 Do Write (#196);
     Write (#217,' ');
END;


(* DISPLAYS THE MENU, CENTERED ON THE SCREEN *)
PROCEDURE DISPLAY_MENU;
Var Top_Line:Byte;
    Left_Col:Byte;
    Menu_Idx:Byte;

BEGIN
    With Menu Do
    Begin
       TextColor (ForeGround);
       TextBackGround (BackGround);
       ClrScr;

       Top_Line := 6;
       Left_Col := 41 - Menu_Width div 2;

       Display_Frame (Num_of_Choices + 3, Menu_Width);

       GotoXY (41-(Length(Title) Div 2), Top_Line);
       Writeln (Title);

       For Menu_Idx := 1 to Num_Of_Choices Do
       Begin
           GotoXy(Left_Col + 2, Top_Line + 2 + Menu_Idx);
           Write (Menu_Keys [Menu_Idx],' - ',Choices [Menu_Idx]);
       End;

       GotoXY(Left_Col + 2, Top_Line + Num_Of_Choices + 6);
       Writeln(Prompt);
    End;
End;


(* GETS THE USERS INPUT *)
PROCEDURE GET_MENU_RESPONCE;
VAR CURRENT_CHOICE, INDEX, LEFT_COL, TOP_LINE:BYTE;
    FUNCTION_KEY, VALID_CHOICE_MADE:BOOLEAN;
    BUFFER_CHAR:CHAR;

BEGIN
    VALID_CHOICE_MADE := FALSE;
    BUFFER_CHAR := ' ';

    WITH MENU DO
    BEGIN
        CURRENT_CHOICE := 1;

        Top_Line := 6;
        Left_Col := 41 - Menu_Width div 2;

        REPEAT

           GOTOXY(LEFT_COL + 2, TOP_LINE + NUM_OF_CHOICES + 4);
           WRITELN(DESCRIPT [CURRENT_CHOICE]);

           GOTOXY (LEFT_COL + 4, TOP_LINE + 2 + CURRENT_CHOICE);

           WRITE (#26);

           BUFFER_CHAR := UPCASE(READKEY);
           FUNCTION_KEY:= FALSE;

           If  Buffer_Char = #0 then
           BEGIN
               Buffer_Char := UpCase (ReadKey);
               Function_Key:= TRUE;
           END;

          IF FUNCTION_KEY
          THEN
            CASE BUFFER_CHAR OF
               UpAr,
               DnAr :BEGIN
                        GOTOXY (LEFT_COL + 4, TOP_LINE + 2 + CURRENT_CHOICE);
                        WRITE ('-');
                        IF BUFFER_CHAR = UpAr THEN DEC(CURRENT_CHOICE)
                                              ELSE INC(CURRENT_CHOICE);

                        IF CURRENT_CHOICE < 1 THEN
                                              CURRENT_CHOICE := NUM_OF_CHOICES;

                        IF CURRENT_CHOICE > NUM_OF_CHOICES THEN
                                                           CURRENT_CHOICE := 1;
                     END;
            END
            ELSE
                IF BUFFER_CHAR=RET
                THEN
                    BUFFER_CHAR := MENU_KEYS[CURRENT_CHOICE];

           FOR INDEX := 1 TO NUM_OF_CHOICES DO
               IF (BUFFER_CHAR = MENU_KEYS[INDEX]) AND
                  (NOT FUNCTION_KEY) THEN
                                      BEGIN
                                          VALID_CHOICE_MADE:=TRUE;
                                          CHOICE := MENU_KEYS[INDEX];
                                      END;

           IF BUFFER_CHAR = ESC THEN
                                BEGIN
                                    VALID_CHOICE_MADE :=TRUE;
                                    CHOICE := MENU_KEYS[NUM_OF_CHOICES];
                                END;

        UNTIL VALID_CHOICE_MADE;
    END;
END;

END. (* END OF UNIT FOR GENERAL MENUS *)
