(* COPYRIGHT (C) 1989 BY JOHN R. CARLING AND MAITRIX SOFTWARE PUBLISHERS *)

{
 The following source code was given to you in order to help the implementation
 stage of TAIME.  The original source coding is copyrighted, but it may be used
 in the system's you implement.

 Changes may also be made to this source code, but John R. Carling and Maitrix
 Software Publishers are not responcible for any of your changes to the code.
 If any changes were to be made, it would not be for functionality, but only
 for fanciness.
}

UNIT PROSOURC;

INTERFACE
        USES CRT, DOS, KEYDEFS, PROTYPES;

CONST
     DAYS   : ARRAY [0..6] of STRING [9] =
              ('Sunday','Monday','Tuesday',
               'Wednesday','Thursday','Friday',
               'Saturday');

TYPE FILE_TYPE=STRING[12];
     A_LINE   =STRING[80];
     STATEMENT=STRING[30];

FUNCTION  FILE_EXIST   (FILE_NAME:FILE_TYPE):BOOLEAN;
PROCEDURE PAUSE;
FUNCTION  GET_CHOICE   (VAR F_KEY:BOOLEAN):CHAR;
{$V-}
PROCEDURE GET_STRING   (VAR DATA:STRING; MAX_LEN:BYTE);
{$V+}
PROCEDURE DISPLAY_TIME_DATE;
PROCEDURE DISPLAY_SYSTEM_STATS;


{ FILE MAINTENANCE ROUTINES }
PROCEDURE READ_USR1    (VAR F:USR_FILE1; VAR DATA:USR_DATA1);
PROCEDURE WRITE_USR1   (VAR F:USR_FILE1; VAR DATA:USR_DATA1);
PROCEDURE READ_USR2    (VAR F:USR_FILE2; VAR DATA:USR_DATA2);
PROCEDURE WRITE_USR2   (VAR F:USR_FILE2; VAR DATA:USR_DATA2);
PROCEDURE READ_USR3    (VAR F:USR_FILE3; VAR DATA:USR_DATA3);
PROCEDURE WRITE_USR3   (VAR F:USR_FILE3; VAR DATA:USR_DATA3);

IMPLEMENTATION

(* checks to see if a file exists on disk in the current directory *)
FUNCTION FILE_EXIST;
Var F:File;
Begin
     {$I-}
       Assign(F,FILE_NAME);
       Reset (F);
       Close (F);
     {$I+}

     IF IORESULT = 0 THEN FILE_EXIST := TRUE
                     ELSE FILE_EXIST := FALSE;
End;  (* File exist function *)


(* pauses for the user to hit a character *)
(* good idea to use a GotoXY command before a call to this *)
PROCEDURE PAUSE;
VAR DUMMY:CHAR;
    F_KEY:BOOLEAN;
BEGIN
   WRITE('Please Press any key to Continue.');
   Dummy:= GET_CHOICE(F_KEY);
END;


FUNCTION GET_CHOICE;
VAR CHOICE:CHAR;
BEGIN
     CHOICE := READKEY;
     F_KEY  :=FALSE;

     IF CHOICE = #0 THEN
     BEGIN
         CHOICE := READKEY;
         F_KEY:=TRUE;
     END;

     GET_CHOICE := CHOICE;
END;


(* USE THIS ROUTINE FOR ALL OF YOUR PROGRAMS WHEN GETTING STRINGS. FAR BETTER
   THAN TURBO PASCAL'S READLN.  IT STORES OLD STRING VALUES FOR EASIER USER
   EDITING, AND ALSO STOPS THE USER FROM TYPING ALL OVER THE SCREEN WHEN THE
   LENGTH IS PASSED IN *)
{$V-}
PROCEDURE GET_STRING;
VAR OLD_DATA:STRING;
    OLD_LEN :BYTE;
    CHAR_CNT:BYTE;
    C2S:CHAR;
    F_KEY:BOOLEAN;
BEGIN
    OLD_DATA:=DATA;
    OLD_LEN :=LENGTH(DATA);

    CHAR_CNT :=0;
    REPEAT
        C2S:=GET_CHOICE(F_KEY);

        IF (C2S=#8) AND (NOT F_KEY)
        THEN
            IF (CHAR_CNT>=1) THEN
                                BEGIN
                                    DEC(CHAR_CNT);
                                    WRITE(C2S);
                                END
            ELSE WRITE(#7)
        ELSE
        IF (F_KEY) THEN
                   CASE C2S OF
                     ENDK:BEGIN
                             GOTOXY(WhereX + (Old_Len-Char_Cnt), WhereY);
                             Char_Cnt:= Old_Len;
                          END;
                     HOME:BEGIN
                             GOTOXY(WhereX - Char_Cnt, WhereY);
                             Char_Cnt:=0;
                          END;
                     RtAr:BEGIN
                            IF (CHAR_CNT < MAX_LEN) AND
                               (CHAR_CNT < OLD_LEN) THEN
                               BEGIN
                                   INC(CHAR_CNT);
                                   GOTOXY(WhereX+1, WhereY);
                               END;
                          END;
                     LtAr:BEGIN
                            IF (CHAR_CNT >=1) THEN
                               BEGIN
                                   DEC(CHAR_CNT);
                                   GOTOXY(WhereX-1, WhereY);
                               END;
                          END;
                   END
        ELSE IF (NOT F_KEY) THEN
             BEGIN
                 IF CHAR_CNT < MAX_LEN THEN WRITE(C2S);
                 INC(CHAR_CNT);
                 IF CHAR_CNT <= MAX_LEN THEN DATA[CHAR_CNT]:=CHR(ORD(C2S));
             END;

    UNTIL (CHAR_CNT = MAX_LEN+1) OR (C2S=#13);

    IF (C2S<>#13) AND (CHAR_CNT < MAX_LEN) THEN
                                           READLN
    ELSE
        IF (CHAR_CNT=MAX_LEN+1) AND (C2S<>#13) THEN
                                               WRITE(#7);
    DEC  (CHAR_CNT);

    (* IF USER DIDN'T WANT THIS FIELD CHANGED, REPLACE WITH OLD_DATA *)
    IF (CHAR_CNT=0) AND (OLD_DATA<>'') THEN
    BEGIN
        FOR CHAR_CNT:=0 TO OLD_LEN DO
            DATA[CHAR_CNT] := OLD_DATA[CHAR_CNT];
        EXIT;
    END;

    (* PADS REMAING LENGTH OF VARIABLE WITH SPACES *)
    DATA[0]:=CHR(CHAR_CNT);
    WHILE (CHAR_CNT < MAX_LEN) DO
    BEGIN
        INC(CHAR_CNT);
        DATA[CHAR_CNT] :=' ';
    END;

    (* WIPES STRING CLEAR IF 1ST AND ONLY CHARACTER IS A SPACE *)
    IF (LENGTH(DATA)=1) AND (DATA[1]=' ') THEN
    BEGIN
        CHAR_CNT:=1;
        WHILE (CHAR_CNT <= MAX_LEN) DO
        BEGIN
            DATA[CHAR_CNT]:=' ';
            INC(CHAR_CNT);
        END;
        DATA[0]:=CHR(0);
    END;
END;
{$V+}


PROCEDURE DISPLAY_TIME_DATE;
VAR MM,DD,YY,DOW,HH,SS,HOS:WORD;
    FG, BG:BYTE; { foreground + background }
BEGIN

    BG := TEXTATTR DIV 16;
    FG := TEXTATTR -  BG*16;
    TEXTCOLOR (BG);             { INVERTS THE CURRENT COLORS }
    TEXTBACKGROUND(FG);
    GOTOXY(1,1); CLREOL;

    GETDATE(YY,MM,DD,DOW);
    GOTOXY (2,1);  WRITELN('DATE: ',DAYS[DOW],', ',MM,'/',DD,'/',YY);
    GETTIME(HH,MM,SS,HOS);
    GOTOXY (66,1); WRITE  ('TIME: ');
    IF HH<10 THEN WRITE ('0');
    WRITE(HH,':');
    IF MM<10 THEN WRITE ('0');
    WRITE(MM,':');
    IF SS<10 THEN WRITE ('0');
    WRITELN(SS);

    TEXTCOLOR(FG);
    TEXTBACKGROUND(BG); { RESTORES COLORS }
END;


PROCEDURE DISPLAY_SYSTEM_STATS;
VAR SIZE,FREE:LONGINT;
    stats :string[80]; (* string for displaying statistic on disk *)
    number:string[20]; (* string for holding #s during conversion *)
    FG, BG:BYTE;

BEGIN
    stats:='';

    SIZE:=DISKSIZE(0);
    FREE:=DISKFREE(0);

    BG := TEXTATTR DIV 16;
    FG := TEXTATTR -  BG*16;
    TEXTCOLOR (BG);             { INVERTS THE CURRENT COLORS }
    TEXTBACKGROUND(FG);

    str(free,number);
    stats:=stats + number + ' bytes free remaining on current drive of ';
    str(size,number);
    stats:=stats + number;

    GOTOXY(1,24); CLREOL;
    gotoxy(40-(length(stats) div 2), 24); write (stats);

    TEXTCOLOR(FG);
    TEXTBACKGROUND(BG);
END;







PROCEDURE READ_USR1;
BEGIN
    READ(F,DATA);
END;
PROCEDURE WRITE_USR1;
BEGIN
    WRITE(F,DATA);
END;


PROCEDURE READ_USR2;
BEGIN
    READ(F,DATA);
END;
PROCEDURE WRITE_USR2;
BEGIN
    WRITE(F,DATA);
END;


PROCEDURE READ_USR3;
BEGIN
    READ(F,DATA);
END;
PROCEDURE WRITE_USR3;
BEGIN
    WRITE(F,DATA);
END;

END. (* END OF UNIT FOR PROTOTYPE SOURCE CODE *)
