(* COPYRIGHT (C) 1989 BY JOHN R. CARLING AND MAITRIX SOFTWARE PUBLISHERS *)
UNIT PROTYPES;

INTERFACE

TYPE
     USR_DATA1 = RECORD
          CUST_LAST_NAME:STRING   [15];
          CUST_FIRST_NAME:STRING   [10];
          CUST_ADDRESS:STRING   [25];
          CUST_CITY:STRING   [15];
          CUST_STATE:STRING   [2];
          CUST_ZIP_CODE:STRING   [10];
          CUST_PHONE_NO:STRING   [12];
          CUST_ACCT_BALANCE:REAL     ;
          CUST_ACCT_NUMBER:INTEGER  ;
     END;

     USR_DATA2 = RECORD
          VENDOR_DATA:USR_DATA1;
          VENDOR_CONTACT:STRING   [25];
     END;

     USR_DATA3 = RECORD
          PART_NUMBER:STRING   [10];
          PART_DESCRIPTION:STRING   [25];
          PART_COST:REAL     ;
          PART_RETAIL:REAL     ;
          PART_QTY_ON_ORDER:INTEGER  ;
          PART_QTY_ON_HAND:INTEGER  ;
          PART_RE_ORDER_POINT:INTEGER  ;
     END;

     USR_FILE1 = FILE OF USR_DATA1;
     USR_FILE2 = FILE OF USR_DATA2;
     USR_FILE3 = FILE OF USR_DATA3;

PROCEDURE CLR_USR_DATA1(VAR DATA:USR_DATA1);
PROCEDURE CLR_USR_DATA2(VAR DATA:USR_DATA2);
PROCEDURE CLR_USR_DATA3(VAR DATA:USR_DATA3);

IMPLEMENTATION

PROCEDURE CLR_USR_DATA1;
Begin 
     WITH DATA DO
     Begin 
          CUST_LAST_NAME:= '';
          CUST_FIRST_NAME:= '';
          CUST_ADDRESS:= '';
          CUST_CITY:='FORKED RIVER';
          CUST_STATE:='NJ';
          CUST_ZIP_CODE:='08731-0000';
          CUST_PHONE_NO:='609-';
          CUST_ACCT_BALANCE:=0.0;
          CUST_ACCT_NUMBER:=0;
     End; 
End; 

PROCEDURE CLR_USR_DATA2;
Begin 
     WITH DATA DO
     Begin 
               WITH VENDOR_DATA DO
     Begin 
          CUST_LAST_NAME:= '';
          CUST_FIRST_NAME:= '';
          CUST_ADDRESS:= '';
          CUST_CITY:='FORKED RIVER';
          CUST_STATE:='NJ';
          CUST_ZIP_CODE:='08731-0000';
          CUST_PHONE_NO:='609-';
          CUST_ACCT_BALANCE:=0.0;
          CUST_ACCT_NUMBER:=0;
     End; 
          VENDOR_CONTACT:='JOE SHMOE';
     End; 
End; 

PROCEDURE CLR_USR_DATA3;
Begin 
     WITH DATA DO
     Begin 
          PART_NUMBER:= '';
          PART_DESCRIPTION:= '';
          PART_COST:=0.0;
          PART_RETAIL:=0.0;
          PART_QTY_ON_ORDER:= 0;
          PART_QTY_ON_HAND:= 0;
          PART_RE_ORDER_POINT:=50;
     End; 
End; 

END. (* END OF UNIT *)
